unit Atom;

interface

type

HCkAtom = Pointer;
HCkTask = Pointer;
HCkDateTime = Pointer;
HCkString = Pointer;


// Note: The callback functions use the cdecl calling convention, while all other functions use stdcall.
TAtomAbortCheck = function(): Integer; cdecl;
TAtomProgressInfo = procedure(name: PWideChar; value: PWideChar); cdecl;
TAtomPercentDone = function(pctDone: Integer): Integer; cdecl;
TAtomTaskCompleted = procedure(task: HCkTask); cdecl;


function CkAtom_Create: HCkAtom;  stdcall;
procedure CkAtom_Dispose(handle: HCkAtom); stdcall;

procedure CkAtom_SetAbortCheck(objHandle: HCkAtom; fn: TAtomAbortCheck) stdcall;
procedure CkAtom_SetProgressInfo(objHandle: HCkAtom; fn: TAtomProgressInfo) stdcall;
procedure CkAtom_SetPercentDone(objHandle: HCkAtom; fn: TAtomPercentDone) stdcall;
procedure CkAtom_SetTaskCompleted(objHandle: HCkAtom; fn: TAtomTaskCompleted) stdcall;
function CkAtom_getAbortCurrent(objHandle: HCkAtom): wordbool;
procedure CkAtom_getDebugLogFilePath(objHandle: HCkAtom; outPropVal: HCkString);
procedure CkAtom_putDebugLogFilePath(objHandle: HCkAtom; newPropVal: PWideChar);
function CkAtom__debugLogFilePath(objHandle: HCkAtom): PWideChar;
procedure CkAtom_getLastErrorHtml(objHandle: HCkAtom; outPropVal: HCkString);
function CkAtom__lastErrorHtml(objHandle: HCkAtom): PWideChar;
procedure CkAtom_getLastErrorText(objHandle: HCkAtom; outPropVal: HCkString);
function CkAtom__lastErrorText(objHandle: HCkAtom): PWideChar;
procedure CkAtom_getLastErrorXml(objHandle: HCkAtom; outPropVal: HCkString);
function CkAtom__lastErrorXml(objHandle: HCkAtom): PWideChar;
function CkAtom_getLastMethodSuccess(objHandle: HCkAtom): wordbool;
procedure CkAtom_putLastMethodSuccess(objHandle: HCkAtom; newPropVal: wordbool);
function CkAtom_getNumEntries(objHandle: HCkAtom): Integer;
function CkAtom_getVerboseLogging(objHandle: HCkAtom): wordbool;
procedure CkAtom_putVerboseLogging(objHandle: HCkAtom; newPropVal: wordbool);
procedure CkAtom_getVersion(objHandle: HCkAtom; outPropVal: HCkString);
function CkAtom__version(objHandle: HCkAtom): PWideChar;
function CkAtom_AddElement(objHandle: HCkAtom; tag: PWideChar; value: PWideChar): Integer;
function CkAtom_AddElementDateStr(objHandle: HCkAtom; tag: PWideChar; dateTimeStr: PWideChar): Integer;
function CkAtom_AddElementDt(objHandle: HCkAtom; tag: PWideChar; dateTime: HCkDateTime): Integer;
function CkAtom_AddElementHtml(objHandle: HCkAtom; tag: PWideChar; htmlStr: PWideChar): Integer;
function CkAtom_AddElementXHtml(objHandle: HCkAtom; tag: PWideChar; xmlStr: PWideChar): Integer;
function CkAtom_AddElementXml(objHandle: HCkAtom; tag: PWideChar; xmlStr: PWideChar): Integer;
procedure CkAtom_AddEntry(objHandle: HCkAtom; xmlStr: PWideChar);
procedure CkAtom_AddLink(objHandle: HCkAtom; rel: PWideChar; href: PWideChar; title: PWideChar; typ: PWideChar);
procedure CkAtom_AddPerson(objHandle: HCkAtom; tag: PWideChar; name: PWideChar; uri: PWideChar; email: PWideChar);
procedure CkAtom_DeleteElement(objHandle: HCkAtom; tag: PWideChar; index: Integer);
procedure CkAtom_DeleteElementAttr(objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar);
procedure CkAtom_DeletePerson(objHandle: HCkAtom; tag: PWideChar; index: Integer);
function CkAtom_DownloadAtom(objHandle: HCkAtom; url: PWideChar): wordbool;
function CkAtom_DownloadAtomAsync(objHandle: HCkAtom; url: PWideChar): HCkTask;
function CkAtom_GetElement(objHandle: HCkAtom; tag: PWideChar; index: Integer; outStr: HCkString): wordbool;
function CkAtom__getElement(objHandle: HCkAtom; tag: PWideChar; index: Integer): PWideChar;
function CkAtom_GetElementAttr(objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar; outStr: HCkString): wordbool;
function CkAtom__getElementAttr(objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar): PWideChar;
function CkAtom_GetElementCount(objHandle: HCkAtom; tag: PWideChar): Integer;
function CkAtom_GetElementDateStr(objHandle: HCkAtom; tag: PWideChar; index: Integer; outStr: HCkString): wordbool;
function CkAtom__getElementDateStr(objHandle: HCkAtom; tag: PWideChar; index: Integer): PWideChar;
function CkAtom_GetElementDt(objHandle: HCkAtom; tag: PWideChar; index: Integer): HCkDateTime;
function CkAtom_GetEntry(objHandle: HCkAtom; index: Integer): HCkAtom;
function CkAtom_GetLinkHref(objHandle: HCkAtom; relName: PWideChar; outStr: HCkString): wordbool;
function CkAtom__getLinkHref(objHandle: HCkAtom; relName: PWideChar): PWideChar;
function CkAtom_GetPersonInfo(objHandle: HCkAtom; tag: PWideChar; index: Integer; tag2: PWideChar; outStr: HCkString): wordbool;
function CkAtom__getPersonInfo(objHandle: HCkAtom; tag: PWideChar; index: Integer; tag2: PWideChar): PWideChar;
function CkAtom_GetTopAttr(objHandle: HCkAtom; attrName: PWideChar; outStr: HCkString): wordbool;
function CkAtom__getTopAttr(objHandle: HCkAtom; attrName: PWideChar): PWideChar;
function CkAtom_HasElement(objHandle: HCkAtom; tag: PWideChar): wordbool;
function CkAtom_LoadTaskCaller(objHandle: HCkAtom; task: HCkTask): wordbool;
function CkAtom_LoadXml(objHandle: HCkAtom; xmlStr: PWideChar): wordbool;
procedure CkAtom_NewEntry(objHandle: HCkAtom);
procedure CkAtom_NewFeed(objHandle: HCkAtom);
function CkAtom_SaveLastError(objHandle: HCkAtom; path: PWideChar): wordbool;
procedure CkAtom_SetElementAttr(objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar; attrValue: PWideChar);
procedure CkAtom_SetTopAttr(objHandle: HCkAtom; attrName: PWideChar; value: PWideChar);
function CkAtom_ToXmlString(objHandle: HCkAtom; outStr: HCkString): wordbool;
function CkAtom__toXmlString(objHandle: HCkAtom): PWideChar;
procedure CkAtom_UpdateElement(objHandle: HCkAtom; tag: PWideChar; index: Integer; value: PWideChar);
procedure CkAtom_UpdateElementDateStr(objHandle: HCkAtom; tag: PWideChar; index: Integer; dateTimeStr: PWideChar);
procedure CkAtom_UpdateElementDt(objHandle: HCkAtom; tag: PWideChar; index: Integer; dateTime: HCkDateTime);
procedure CkAtom_UpdateElementHtml(objHandle: HCkAtom; tag: PWideChar; index: Integer; htmlStr: PWideChar);
procedure CkAtom_UpdateElementXHtml(objHandle: HCkAtom; tag: PWideChar; index: Integer; xmlStr: PWideChar);
procedure CkAtom_UpdateElementXml(objHandle: HCkAtom; tag: PWideChar; index: Integer; xmlStr: PWideChar);
procedure CkAtom_UpdatePerson(objHandle: HCkAtom; tag: PWideChar; index: Integer; name: PWideChar; uri: PWideChar; email: PWideChar);
implementation

uses Winapi.Windows, System.SysUtils, ckDllLoader;

Type
  TCkAtom_Create = function : HCkAtom; stdcall;
  TCkAtom_Dispose = procedure (handle: HCkAtom); stdcall;
  TCkAtom_SetAbortCheck = procedure (objHandle: HCkAtom; fn: TAtomAbortCheck); stdcall;
  TCkAtom_SetProgressInfo = procedure (objHandle: HCkAtom; fn: TAtomProgressInfo); stdcall;
  TCkAtom_SetPercentDone = procedure (objHandle: HCkAtom; fn: TAtomPercentDone); stdcall;
  TCkAtom_SetTaskCompleted = procedure (objHandle: HCkAtom; fn: TAtomTaskCompleted); stdcall;
  TCkAtom_getAbortCurrent = function (objHandle: HCkAtom): wordbool; stdcall;
  TCkAtom_getDebugLogFilePath = procedure (objHandle: HCkAtom; outPropVal: HCkString); stdcall;
  TCkAtom_putDebugLogFilePath = procedure (objHandle: HCkAtom; newPropVal: PWideChar); stdcall;
  TCkAtom__debugLogFilePath = function (objHandle: HCkAtom): PWideChar; stdcall;
  TCkAtom_getLastErrorHtml = procedure (objHandle: HCkAtom; outPropVal: HCkString); stdcall;
  TCkAtom__lastErrorHtml = function (objHandle: HCkAtom): PWideChar; stdcall;
  TCkAtom_getLastErrorText = procedure (objHandle: HCkAtom; outPropVal: HCkString); stdcall;
  TCkAtom__lastErrorText = function (objHandle: HCkAtom): PWideChar; stdcall;
  TCkAtom_getLastErrorXml = procedure (objHandle: HCkAtom; outPropVal: HCkString); stdcall;
  TCkAtom__lastErrorXml = function (objHandle: HCkAtom): PWideChar; stdcall;
  TCkAtom_getLastMethodSuccess = function (objHandle: HCkAtom): wordbool; stdcall;
  TCkAtom_putLastMethodSuccess = procedure (objHandle: HCkAtom; newPropVal: wordbool); stdcall;
  TCkAtom_getNumEntries = function (objHandle: HCkAtom): Integer; stdcall;
  TCkAtom_getVerboseLogging = function (objHandle: HCkAtom): wordbool; stdcall;
  TCkAtom_putVerboseLogging = procedure (objHandle: HCkAtom; newPropVal: wordbool); stdcall;
  TCkAtom_getVersion = procedure (objHandle: HCkAtom; outPropVal: HCkString); stdcall;
  TCkAtom__version = function (objHandle: HCkAtom): PWideChar; stdcall;
  TCkAtom_AddElement = function (objHandle: HCkAtom; tag: PWideChar; value: PWideChar): Integer; stdcall;
  TCkAtom_AddElementDateStr = function (objHandle: HCkAtom; tag: PWideChar; dateTimeStr: PWideChar): Integer; stdcall;
  TCkAtom_AddElementDt = function (objHandle: HCkAtom; tag: PWideChar; dateTime: HCkDateTime): Integer; stdcall;
  TCkAtom_AddElementHtml = function (objHandle: HCkAtom; tag: PWideChar; htmlStr: PWideChar): Integer; stdcall;
  TCkAtom_AddElementXHtml = function (objHandle: HCkAtom; tag: PWideChar; xmlStr: PWideChar): Integer; stdcall;
  TCkAtom_AddElementXml = function (objHandle: HCkAtom; tag: PWideChar; xmlStr: PWideChar): Integer; stdcall;
  TCkAtom_AddEntry = procedure (objHandle: HCkAtom; xmlStr: PWideChar); stdcall;
  TCkAtom_AddLink = procedure (objHandle: HCkAtom; rel: PWideChar; href: PWideChar; title: PWideChar; typ: PWideChar); stdcall;
  TCkAtom_AddPerson = procedure (objHandle: HCkAtom; tag: PWideChar; name: PWideChar; uri: PWideChar; email: PWideChar); stdcall;
  TCkAtom_DeleteElement = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer); stdcall;
  TCkAtom_DeleteElementAttr = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar); stdcall;
  TCkAtom_DeletePerson = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer); stdcall;
  TCkAtom_DownloadAtom = function (objHandle: HCkAtom; url: PWideChar): wordbool; stdcall;
  TCkAtom_DownloadAtomAsync = function (objHandle: HCkAtom; url: PWideChar): HCkTask; stdcall;
  TCkAtom_GetElement = function (objHandle: HCkAtom; tag: PWideChar; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkAtom__getElement = function (objHandle: HCkAtom; tag: PWideChar; index: Integer): PWideChar; stdcall;
  TCkAtom_GetElementAttr = function (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar; outStr: HCkString): wordbool; stdcall;
  TCkAtom__getElementAttr = function (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar): PWideChar; stdcall;
  TCkAtom_GetElementCount = function (objHandle: HCkAtom; tag: PWideChar): Integer; stdcall;
  TCkAtom_GetElementDateStr = function (objHandle: HCkAtom; tag: PWideChar; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkAtom__getElementDateStr = function (objHandle: HCkAtom; tag: PWideChar; index: Integer): PWideChar; stdcall;
  TCkAtom_GetElementDt = function (objHandle: HCkAtom; tag: PWideChar; index: Integer): HCkDateTime; stdcall;
  TCkAtom_GetEntry = function (objHandle: HCkAtom; index: Integer): HCkAtom; stdcall;
  TCkAtom_GetLinkHref = function (objHandle: HCkAtom; relName: PWideChar; outStr: HCkString): wordbool; stdcall;
  TCkAtom__getLinkHref = function (objHandle: HCkAtom; relName: PWideChar): PWideChar; stdcall;
  TCkAtom_GetPersonInfo = function (objHandle: HCkAtom; tag: PWideChar; index: Integer; tag2: PWideChar; outStr: HCkString): wordbool; stdcall;
  TCkAtom__getPersonInfo = function (objHandle: HCkAtom; tag: PWideChar; index: Integer; tag2: PWideChar): PWideChar; stdcall;
  TCkAtom_GetTopAttr = function (objHandle: HCkAtom; attrName: PWideChar; outStr: HCkString): wordbool; stdcall;
  TCkAtom__getTopAttr = function (objHandle: HCkAtom; attrName: PWideChar): PWideChar; stdcall;
  TCkAtom_HasElement = function (objHandle: HCkAtom; tag: PWideChar): wordbool; stdcall;
  TCkAtom_LoadTaskCaller = function (objHandle: HCkAtom; task: HCkTask): wordbool; stdcall;
  TCkAtom_LoadXml = function (objHandle: HCkAtom; xmlStr: PWideChar): wordbool; stdcall;
  TCkAtom_NewEntry = procedure (objHandle: HCkAtom); stdcall;
  TCkAtom_NewFeed = procedure (objHandle: HCkAtom); stdcall;
  TCkAtom_SaveLastError = function (objHandle: HCkAtom; path: PWideChar): wordbool; stdcall;
  TCkAtom_SetElementAttr = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar; attrValue: PWideChar); stdcall;
  TCkAtom_SetTopAttr = procedure (objHandle: HCkAtom; attrName: PWideChar; value: PWideChar); stdcall;
  TCkAtom_ToXmlString = function (objHandle: HCkAtom; outStr: HCkString): wordbool; stdcall;
  TCkAtom__toXmlString = function (objHandle: HCkAtom): PWideChar; stdcall;
  TCkAtom_UpdateElement = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; value: PWideChar); stdcall;
  TCkAtom_UpdateElementDateStr = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; dateTimeStr: PWideChar); stdcall;
  TCkAtom_UpdateElementDt = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; dateTime: HCkDateTime); stdcall;
  TCkAtom_UpdateElementHtml = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; htmlStr: PWideChar); stdcall;
  TCkAtom_UpdateElementXHtml = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; xmlStr: PWideChar); stdcall;
  TCkAtom_UpdateElementXml = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; xmlStr: PWideChar); stdcall;
  TCkAtom_UpdatePerson = procedure (objHandle: HCkAtom; tag: PWideChar; index: Integer; name: PWideChar; uri: PWideChar; email: PWideChar); stdcall;

var
  _fkt_ptr_arr:   array [0..68] of Pointer;

function _Map( k:Integer; n:String):Pointer;
begin
  Result:=  _fkt_ptr_arr[k];
  if Result = nil then begin
    Chilkat_GetProcedureAddress(Result, n);
    _fkt_ptr_arr[k]:=   Result;
  end;
end;


function CkAtom_Create : HCkAtom;
begin
  result := TCkAtom_Create(_map(0, 'CkAtom_Create'));
end;

procedure CkAtom_Dispose (handle: HCkAtom);
begin
  TCkAtom_Dispose(_map(1, 'CkAtom_Dispose'))
    (handle);
end;


procedure CkAtom_SetAbortCheck (objHandle: HCkAtom; fn: TAtomAbortCheck);
begin
    TCkAtom_SetAbortCheck(_map(2, 'CkAtom_SetAbortCheck'))
    (objHandle, fn);
end;
procedure CkAtom_SetProgressInfo (objHandle: HCkAtom; fn: TAtomProgressInfo);
begin
    TCkAtom_SetProgressInfo(_map(3, 'CkAtom_SetProgressInfo'))
    (objHandle, fn);
end;
procedure CkAtom_SetPercentDone (objHandle: HCkAtom; fn: TAtomPercentDone);
begin
    TCkAtom_SetPercentDone(_map(4, 'CkAtom_SetPercentDone'))
    (objHandle, fn);
end;
procedure CkAtom_SetTaskCompleted (objHandle: HCkAtom; fn: TAtomTaskCompleted);
begin
    TCkAtom_SetTaskCompleted(_map(5, 'CkAtom_SetTaskCompleted'))
    (objHandle, fn);
end;

function CkAtom_getAbortCurrent (objHandle: HCkAtom): wordbool;
begin
    result := TCkAtom_getAbortCurrent(_map(6, 'CkAtom_getAbortCurrent'))
    (objHandle);
end;

procedure CkAtom_getDebugLogFilePath (objHandle: HCkAtom; outPropVal: HCkString);
begin
  TCkAtom_getDebugLogFilePath(_map(7, 'CkAtom_getDebugLogFilePath'))
    (objHandle, outPropVal);
end;

procedure CkAtom_putDebugLogFilePath (objHandle: HCkAtom; newPropVal: PWideChar);
begin
  TCkAtom_putDebugLogFilePath(_map(8, 'CkAtom_putDebugLogFilePath'))
    (objHandle, newPropVal);
end;

function CkAtom__debugLogFilePath (objHandle: HCkAtom): PWideChar;
begin
  result := TCkAtom__debugLogFilePath(_map(9, 'CkAtom__debugLogFilePath'))
    (objHandle);
end;

procedure CkAtom_getLastErrorHtml (objHandle: HCkAtom; outPropVal: HCkString);
begin
  TCkAtom_getLastErrorHtml(_map(10, 'CkAtom_getLastErrorHtml'))
    (objHandle, outPropVal);
end;

function CkAtom__lastErrorHtml (objHandle: HCkAtom): PWideChar;
begin
  result := TCkAtom__lastErrorHtml(_map(11, 'CkAtom__lastErrorHtml'))
    (objHandle);
end;

procedure CkAtom_getLastErrorText (objHandle: HCkAtom; outPropVal: HCkString);
begin
  TCkAtom_getLastErrorText(_map(12, 'CkAtom_getLastErrorText'))
    (objHandle, outPropVal);
end;

function CkAtom__lastErrorText (objHandle: HCkAtom): PWideChar;
begin
  result := TCkAtom__lastErrorText(_map(13, 'CkAtom__lastErrorText'))
    (objHandle);
end;

procedure CkAtom_getLastErrorXml (objHandle: HCkAtom; outPropVal: HCkString);
begin
  TCkAtom_getLastErrorXml(_map(14, 'CkAtom_getLastErrorXml'))
    (objHandle, outPropVal);
end;

function CkAtom__lastErrorXml (objHandle: HCkAtom): PWideChar;
begin
  result := TCkAtom__lastErrorXml(_map(15, 'CkAtom__lastErrorXml'))
    (objHandle);
end;

function CkAtom_getLastMethodSuccess (objHandle: HCkAtom): wordbool;
begin
    result := TCkAtom_getLastMethodSuccess(_map(16, 'CkAtom_getLastMethodSuccess'))
    (objHandle);
end;

procedure CkAtom_putLastMethodSuccess (objHandle: HCkAtom; newPropVal: wordbool);
begin
  TCkAtom_putLastMethodSuccess(_map(17, 'CkAtom_putLastMethodSuccess'))
    (objHandle, newPropVal);
end;

function CkAtom_getNumEntries (objHandle: HCkAtom): Integer;
begin
    result := TCkAtom_getNumEntries(_map(18, 'CkAtom_getNumEntries'))
    (objHandle);
end;

function CkAtom_getVerboseLogging (objHandle: HCkAtom): wordbool;
begin
    result := TCkAtom_getVerboseLogging(_map(19, 'CkAtom_getVerboseLogging'))
    (objHandle);
end;

procedure CkAtom_putVerboseLogging (objHandle: HCkAtom; newPropVal: wordbool);
begin
  TCkAtom_putVerboseLogging(_map(20, 'CkAtom_putVerboseLogging'))
    (objHandle, newPropVal);
end;

procedure CkAtom_getVersion (objHandle: HCkAtom; outPropVal: HCkString);
begin
  TCkAtom_getVersion(_map(21, 'CkAtom_getVersion'))
    (objHandle, outPropVal);
end;

function CkAtom__version (objHandle: HCkAtom): PWideChar;
begin
  result := TCkAtom__version(_map(22, 'CkAtom__version'))
    (objHandle);
end;

function CkAtom_AddElement (objHandle: HCkAtom; tag: PWideChar; value: PWideChar): Integer;
begin
  result := TCkAtom_AddElement(_map(23, 'CkAtom_AddElement'))
    (objHandle, tag, value);
end;

function CkAtom_AddElementDateStr (objHandle: HCkAtom; tag: PWideChar; dateTimeStr: PWideChar): Integer;
begin
  result := TCkAtom_AddElementDateStr(_map(24, 'CkAtom_AddElementDateStr'))
    (objHandle, tag, dateTimeStr);
end;

function CkAtom_AddElementDt (objHandle: HCkAtom; tag: PWideChar; dateTime: HCkDateTime): Integer;
begin
  result := TCkAtom_AddElementDt(_map(25, 'CkAtom_AddElementDt'))
    (objHandle, tag, dateTime);
end;

function CkAtom_AddElementHtml (objHandle: HCkAtom; tag: PWideChar; htmlStr: PWideChar): Integer;
begin
  result := TCkAtom_AddElementHtml(_map(26, 'CkAtom_AddElementHtml'))
    (objHandle, tag, htmlStr);
end;

function CkAtom_AddElementXHtml (objHandle: HCkAtom; tag: PWideChar; xmlStr: PWideChar): Integer;
begin
  result := TCkAtom_AddElementXHtml(_map(27, 'CkAtom_AddElementXHtml'))
    (objHandle, tag, xmlStr);
end;

function CkAtom_AddElementXml (objHandle: HCkAtom; tag: PWideChar; xmlStr: PWideChar): Integer;
begin
  result := TCkAtom_AddElementXml(_map(28, 'CkAtom_AddElementXml'))
    (objHandle, tag, xmlStr);
end;

procedure CkAtom_AddEntry (objHandle: HCkAtom; xmlStr: PWideChar);
begin
  TCkAtom_AddEntry(_map(29, 'CkAtom_AddEntry'))
    (objHandle, xmlStr);
end;

procedure CkAtom_AddLink (objHandle: HCkAtom; rel: PWideChar; href: PWideChar; title: PWideChar; typ: PWideChar);
begin
  TCkAtom_AddLink(_map(30, 'CkAtom_AddLink'))
    (objHandle, rel, href, title, typ);
end;

procedure CkAtom_AddPerson (objHandle: HCkAtom; tag: PWideChar; name: PWideChar; uri: PWideChar; email: PWideChar);
begin
  TCkAtom_AddPerson(_map(31, 'CkAtom_AddPerson'))
    (objHandle, tag, name, uri, email);
end;

procedure CkAtom_DeleteElement (objHandle: HCkAtom; tag: PWideChar; index: Integer);
begin
  TCkAtom_DeleteElement(_map(32, 'CkAtom_DeleteElement'))
    (objHandle, tag, index);
end;

procedure CkAtom_DeleteElementAttr (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar);
begin
  TCkAtom_DeleteElementAttr(_map(33, 'CkAtom_DeleteElementAttr'))
    (objHandle, tag, index, attrName);
end;

procedure CkAtom_DeletePerson (objHandle: HCkAtom; tag: PWideChar; index: Integer);
begin
  TCkAtom_DeletePerson(_map(34, 'CkAtom_DeletePerson'))
    (objHandle, tag, index);
end;

function CkAtom_DownloadAtom (objHandle: HCkAtom; url: PWideChar): wordbool;
begin
  result := TCkAtom_DownloadAtom(_map(35, 'CkAtom_DownloadAtom'))
    (objHandle, url);
end;

function CkAtom_DownloadAtomAsync (objHandle: HCkAtom; url: PWideChar): HCkTask;
begin
  result := TCkAtom_DownloadAtomAsync(_map(36, 'CkAtom_DownloadAtomAsync'))
    (objHandle, url);
end;

function CkAtom_GetElement (objHandle: HCkAtom; tag: PWideChar; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkAtom_GetElement(_map(37, 'CkAtom_GetElement'))
    (objHandle, tag, index, outStr);
end;

function CkAtom__getElement (objHandle: HCkAtom; tag: PWideChar; index: Integer): PWideChar;
begin
  result := TCkAtom__getElement(_map(38, 'CkAtom__getElement'))
    (objHandle, tag, index);
end;

function CkAtom_GetElementAttr (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar; outStr: HCkString): wordbool;
begin
  result := TCkAtom_GetElementAttr(_map(39, 'CkAtom_GetElementAttr'))
    (objHandle, tag, index, attrName, outStr);
end;

function CkAtom__getElementAttr (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar): PWideChar;
begin
  result := TCkAtom__getElementAttr(_map(40, 'CkAtom__getElementAttr'))
    (objHandle, tag, index, attrName);
end;

function CkAtom_GetElementCount (objHandle: HCkAtom; tag: PWideChar): Integer;
begin
  result := TCkAtom_GetElementCount(_map(41, 'CkAtom_GetElementCount'))
    (objHandle, tag);
end;

function CkAtom_GetElementDateStr (objHandle: HCkAtom; tag: PWideChar; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkAtom_GetElementDateStr(_map(42, 'CkAtom_GetElementDateStr'))
    (objHandle, tag, index, outStr);
end;

function CkAtom__getElementDateStr (objHandle: HCkAtom; tag: PWideChar; index: Integer): PWideChar;
begin
  result := TCkAtom__getElementDateStr(_map(43, 'CkAtom__getElementDateStr'))
    (objHandle, tag, index);
end;

function CkAtom_GetElementDt (objHandle: HCkAtom; tag: PWideChar; index: Integer): HCkDateTime;
begin
  result := TCkAtom_GetElementDt(_map(44, 'CkAtom_GetElementDt'))
    (objHandle, tag, index);
end;

function CkAtom_GetEntry (objHandle: HCkAtom; index: Integer): HCkAtom;
begin
  result := TCkAtom_GetEntry(_map(45, 'CkAtom_GetEntry'))
    (objHandle, index);
end;

function CkAtom_GetLinkHref (objHandle: HCkAtom; relName: PWideChar; outStr: HCkString): wordbool;
begin
  result := TCkAtom_GetLinkHref(_map(46, 'CkAtom_GetLinkHref'))
    (objHandle, relName, outStr);
end;

function CkAtom__getLinkHref (objHandle: HCkAtom; relName: PWideChar): PWideChar;
begin
  result := TCkAtom__getLinkHref(_map(47, 'CkAtom__getLinkHref'))
    (objHandle, relName);
end;

function CkAtom_GetPersonInfo (objHandle: HCkAtom; tag: PWideChar; index: Integer; tag2: PWideChar; outStr: HCkString): wordbool;
begin
  result := TCkAtom_GetPersonInfo(_map(48, 'CkAtom_GetPersonInfo'))
    (objHandle, tag, index, tag2, outStr);
end;

function CkAtom__getPersonInfo (objHandle: HCkAtom; tag: PWideChar; index: Integer; tag2: PWideChar): PWideChar;
begin
  result := TCkAtom__getPersonInfo(_map(49, 'CkAtom__getPersonInfo'))
    (objHandle, tag, index, tag2);
end;

function CkAtom_GetTopAttr (objHandle: HCkAtom; attrName: PWideChar; outStr: HCkString): wordbool;
begin
  result := TCkAtom_GetTopAttr(_map(50, 'CkAtom_GetTopAttr'))
    (objHandle, attrName, outStr);
end;

function CkAtom__getTopAttr (objHandle: HCkAtom; attrName: PWideChar): PWideChar;
begin
  result := TCkAtom__getTopAttr(_map(51, 'CkAtom__getTopAttr'))
    (objHandle, attrName);
end;

function CkAtom_HasElement (objHandle: HCkAtom; tag: PWideChar): wordbool;
begin
  result := TCkAtom_HasElement(_map(52, 'CkAtom_HasElement'))
    (objHandle, tag);
end;

function CkAtom_LoadTaskCaller (objHandle: HCkAtom; task: HCkTask): wordbool;
begin
  result := TCkAtom_LoadTaskCaller(_map(53, 'CkAtom_LoadTaskCaller'))
    (objHandle, task);
end;

function CkAtom_LoadXml (objHandle: HCkAtom; xmlStr: PWideChar): wordbool;
begin
  result := TCkAtom_LoadXml(_map(54, 'CkAtom_LoadXml'))
    (objHandle, xmlStr);
end;

procedure CkAtom_NewEntry (objHandle: HCkAtom);
begin
  TCkAtom_NewEntry(_map(55, 'CkAtom_NewEntry'))
    (objHandle);
end;

procedure CkAtom_NewFeed (objHandle: HCkAtom);
begin
  TCkAtom_NewFeed(_map(56, 'CkAtom_NewFeed'))
    (objHandle);
end;

function CkAtom_SaveLastError (objHandle: HCkAtom; path: PWideChar): wordbool;
begin
  result := TCkAtom_SaveLastError(_map(57, 'CkAtom_SaveLastError'))
    (objHandle, path);
end;

procedure CkAtom_SetElementAttr (objHandle: HCkAtom; tag: PWideChar; index: Integer; attrName: PWideChar; attrValue: PWideChar);
begin
  TCkAtom_SetElementAttr(_map(58, 'CkAtom_SetElementAttr'))
    (objHandle, tag, index, attrName, attrValue);
end;

procedure CkAtom_SetTopAttr (objHandle: HCkAtom; attrName: PWideChar; value: PWideChar);
begin
  TCkAtom_SetTopAttr(_map(59, 'CkAtom_SetTopAttr'))
    (objHandle, attrName, value);
end;

function CkAtom_ToXmlString (objHandle: HCkAtom; outStr: HCkString): wordbool;
begin
  result := TCkAtom_ToXmlString(_map(60, 'CkAtom_ToXmlString'))
    (objHandle, outStr);
end;

function CkAtom__toXmlString (objHandle: HCkAtom): PWideChar;
begin
  result := TCkAtom__toXmlString(_map(61, 'CkAtom__toXmlString'))
    (objHandle);
end;

procedure CkAtom_UpdateElement (objHandle: HCkAtom; tag: PWideChar; index: Integer; value: PWideChar);
begin
  TCkAtom_UpdateElement(_map(62, 'CkAtom_UpdateElement'))
    (objHandle, tag, index, value);
end;

procedure CkAtom_UpdateElementDateStr (objHandle: HCkAtom; tag: PWideChar; index: Integer; dateTimeStr: PWideChar);
begin
  TCkAtom_UpdateElementDateStr(_map(63, 'CkAtom_UpdateElementDateStr'))
    (objHandle, tag, index, dateTimeStr);
end;

procedure CkAtom_UpdateElementDt (objHandle: HCkAtom; tag: PWideChar; index: Integer; dateTime: HCkDateTime);
begin
  TCkAtom_UpdateElementDt(_map(64, 'CkAtom_UpdateElementDt'))
    (objHandle, tag, index, dateTime);
end;

procedure CkAtom_UpdateElementHtml (objHandle: HCkAtom; tag: PWideChar; index: Integer; htmlStr: PWideChar);
begin
  TCkAtom_UpdateElementHtml(_map(65, 'CkAtom_UpdateElementHtml'))
    (objHandle, tag, index, htmlStr);
end;

procedure CkAtom_UpdateElementXHtml (objHandle: HCkAtom; tag: PWideChar; index: Integer; xmlStr: PWideChar);
begin
  TCkAtom_UpdateElementXHtml(_map(66, 'CkAtom_UpdateElementXHtml'))
    (objHandle, tag, index, xmlStr);
end;

procedure CkAtom_UpdateElementXml (objHandle: HCkAtom; tag: PWideChar; index: Integer; xmlStr: PWideChar);
begin
  TCkAtom_UpdateElementXml(_map(67, 'CkAtom_UpdateElementXml'))
    (objHandle, tag, index, xmlStr);
end;

procedure CkAtom_UpdatePerson (objHandle: HCkAtom; tag: PWideChar; index: Integer; name: PWideChar; uri: PWideChar; email: PWideChar);
begin
  TCkAtom_UpdatePerson(_map(68, 'CkAtom_UpdatePerson'))
    (objHandle, tag, index, name, uri, email);
end;

end.
