unit Csp;

interface

type

HCkStringTable = Pointer;
HCkString = Pointer;
HCkStringArray = Pointer;
HCkCsp = Pointer;


function CkCsp_Create: HCkCsp;  stdcall;
procedure CkCsp_Dispose(handle: HCkCsp); stdcall;
procedure CkCsp_getDebugLogFilePath(objHandle: HCkCsp; outPropVal: HCkString);
procedure CkCsp_putDebugLogFilePath(objHandle: HCkCsp; newPropVal: PWideChar);
function CkCsp__debugLogFilePath(objHandle: HCkCsp): PWideChar;
procedure CkCsp_getEncryptAlgorithm(objHandle: HCkCsp; outPropVal: HCkString);
function CkCsp__encryptAlgorithm(objHandle: HCkCsp): PWideChar;
function CkCsp_getEncryptAlgorithmID(objHandle: HCkCsp): Integer;
function CkCsp_getEncryptNumBits(objHandle: HCkCsp): Integer;
procedure CkCsp_getHashAlgorithm(objHandle: HCkCsp; outPropVal: HCkString);
function CkCsp__hashAlgorithm(objHandle: HCkCsp): PWideChar;
function CkCsp_getHashAlgorithmID(objHandle: HCkCsp): Integer;
function CkCsp_getHashNumBits(objHandle: HCkCsp): Integer;
procedure CkCsp_getKeyContainerName(objHandle: HCkCsp; outPropVal: HCkString);
procedure CkCsp_putKeyContainerName(objHandle: HCkCsp; newPropVal: PWideChar);
function CkCsp__keyContainerName(objHandle: HCkCsp): PWideChar;
procedure CkCsp_getLastErrorHtml(objHandle: HCkCsp; outPropVal: HCkString);
function CkCsp__lastErrorHtml(objHandle: HCkCsp): PWideChar;
procedure CkCsp_getLastErrorText(objHandle: HCkCsp; outPropVal: HCkString);
function CkCsp__lastErrorText(objHandle: HCkCsp): PWideChar;
procedure CkCsp_getLastErrorXml(objHandle: HCkCsp; outPropVal: HCkString);
function CkCsp__lastErrorXml(objHandle: HCkCsp): PWideChar;
function CkCsp_getLastMethodSuccess(objHandle: HCkCsp): wordbool;
procedure CkCsp_putLastMethodSuccess(objHandle: HCkCsp; newPropVal: wordbool);
function CkCsp_getMachineKeyset(objHandle: HCkCsp): wordbool;
procedure CkCsp_putMachineKeyset(objHandle: HCkCsp; newPropVal: wordbool);
function CkCsp_getNumEncryptAlgorithms(objHandle: HCkCsp): Integer;
function CkCsp_getNumHashAlgorithms(objHandle: HCkCsp): Integer;
function CkCsp_getNumKeyContainers(objHandle: HCkCsp): Integer;
function CkCsp_getNumKeyExchangeAlgorithms(objHandle: HCkCsp): Integer;
function CkCsp_getNumSignatureAlgorithms(objHandle: HCkCsp): Integer;
procedure CkCsp_getProviderName(objHandle: HCkCsp; outPropVal: HCkString);
procedure CkCsp_putProviderName(objHandle: HCkCsp; newPropVal: PWideChar);
function CkCsp__providerName(objHandle: HCkCsp): PWideChar;
function CkCsp_getProviderType(objHandle: HCkCsp): Integer;
procedure CkCsp_getUncommonOptions(objHandle: HCkCsp; outPropVal: HCkString);
procedure CkCsp_putUncommonOptions(objHandle: HCkCsp; newPropVal: PWideChar);
function CkCsp__uncommonOptions(objHandle: HCkCsp): PWideChar;
function CkCsp_getVerboseLogging(objHandle: HCkCsp): wordbool;
procedure CkCsp_putVerboseLogging(objHandle: HCkCsp; newPropVal: wordbool);
procedure CkCsp_getVersion(objHandle: HCkCsp; outPropVal: HCkString);
function CkCsp__version(objHandle: HCkCsp): PWideChar;
function CkCsp_GetKeyContainerNames(objHandle: HCkCsp): HCkStringArray;
function CkCsp_GetProviders(objHandle: HCkCsp; providerNames: HCkStringTable): wordbool;
function CkCsp_HasEncryptAlgorithm(objHandle: HCkCsp; name: PWideChar; numBits: Integer): wordbool;
function CkCsp_HasHashAlgorithm(objHandle: HCkCsp; name: PWideChar; numBits: Integer): wordbool;
function CkCsp_Initialize(objHandle: HCkCsp): wordbool;
function CkCsp_NthEncryptionAlgorithm(objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
function CkCsp__nthEncryptionAlgorithm(objHandle: HCkCsp; index: Integer): PWideChar;
function CkCsp_NthEncryptionNumBits(objHandle: HCkCsp; index: Integer): Integer;
function CkCsp_NthHashAlgorithmName(objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
function CkCsp__nthHashAlgorithmName(objHandle: HCkCsp; index: Integer): PWideChar;
function CkCsp_NthHashNumBits(objHandle: HCkCsp; index: Integer): Integer;
function CkCsp_NthKeyContainerName(objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
function CkCsp__nthKeyContainerName(objHandle: HCkCsp; index: Integer): PWideChar;
function CkCsp_NthKeyExchangeAlgorithm(objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
function CkCsp__nthKeyExchangeAlgorithm(objHandle: HCkCsp; index: Integer): PWideChar;
function CkCsp_NthKeyExchangeNumBits(objHandle: HCkCsp; index: Integer): Integer;
function CkCsp_NthSignatureAlgorithm(objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
function CkCsp__nthSignatureAlgorithm(objHandle: HCkCsp; index: Integer): PWideChar;
function CkCsp_NthSignatureNumBits(objHandle: HCkCsp; index: Integer): Integer;
function CkCsp_SaveLastError(objHandle: HCkCsp; path: PWideChar): wordbool;
function CkCsp_SetEncryptAlgorithm(objHandle: HCkCsp; name: PWideChar): Integer;
function CkCsp_SetHashAlgorithm(objHandle: HCkCsp; name: PWideChar): Integer;
implementation

uses Winapi.Windows, System.SysUtils, ckDllLoader;

Type
  TCkCsp_Create = function : HCkCsp; stdcall;
  TCkCsp_Dispose = procedure (handle: HCkCsp); stdcall;
  TCkCsp_getDebugLogFilePath = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp_putDebugLogFilePath = procedure (objHandle: HCkCsp; newPropVal: PWideChar); stdcall;
  TCkCsp__debugLogFilePath = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getEncryptAlgorithm = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp__encryptAlgorithm = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getEncryptAlgorithmID = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getEncryptNumBits = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getHashAlgorithm = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp__hashAlgorithm = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getHashAlgorithmID = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getHashNumBits = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getKeyContainerName = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp_putKeyContainerName = procedure (objHandle: HCkCsp; newPropVal: PWideChar); stdcall;
  TCkCsp__keyContainerName = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getLastErrorHtml = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp__lastErrorHtml = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getLastErrorText = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp__lastErrorText = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getLastErrorXml = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp__lastErrorXml = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getLastMethodSuccess = function (objHandle: HCkCsp): wordbool; stdcall;
  TCkCsp_putLastMethodSuccess = procedure (objHandle: HCkCsp; newPropVal: wordbool); stdcall;
  TCkCsp_getMachineKeyset = function (objHandle: HCkCsp): wordbool; stdcall;
  TCkCsp_putMachineKeyset = procedure (objHandle: HCkCsp; newPropVal: wordbool); stdcall;
  TCkCsp_getNumEncryptAlgorithms = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getNumHashAlgorithms = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getNumKeyContainers = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getNumKeyExchangeAlgorithms = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getNumSignatureAlgorithms = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getProviderName = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp_putProviderName = procedure (objHandle: HCkCsp; newPropVal: PWideChar); stdcall;
  TCkCsp__providerName = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getProviderType = function (objHandle: HCkCsp): Integer; stdcall;
  TCkCsp_getUncommonOptions = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp_putUncommonOptions = procedure (objHandle: HCkCsp; newPropVal: PWideChar); stdcall;
  TCkCsp__uncommonOptions = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_getVerboseLogging = function (objHandle: HCkCsp): wordbool; stdcall;
  TCkCsp_putVerboseLogging = procedure (objHandle: HCkCsp; newPropVal: wordbool); stdcall;
  TCkCsp_getVersion = procedure (objHandle: HCkCsp; outPropVal: HCkString); stdcall;
  TCkCsp__version = function (objHandle: HCkCsp): PWideChar; stdcall;
  TCkCsp_GetKeyContainerNames = function (objHandle: HCkCsp): HCkStringArray; stdcall;
  TCkCsp_GetProviders = function (objHandle: HCkCsp; providerNames: HCkStringTable): wordbool; stdcall;
  TCkCsp_HasEncryptAlgorithm = function (objHandle: HCkCsp; name: PWideChar; numBits: Integer): wordbool; stdcall;
  TCkCsp_HasHashAlgorithm = function (objHandle: HCkCsp; name: PWideChar; numBits: Integer): wordbool; stdcall;
  TCkCsp_Initialize = function (objHandle: HCkCsp): wordbool; stdcall;
  TCkCsp_NthEncryptionAlgorithm = function (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkCsp__nthEncryptionAlgorithm = function (objHandle: HCkCsp; index: Integer): PWideChar; stdcall;
  TCkCsp_NthEncryptionNumBits = function (objHandle: HCkCsp; index: Integer): Integer; stdcall;
  TCkCsp_NthHashAlgorithmName = function (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkCsp__nthHashAlgorithmName = function (objHandle: HCkCsp; index: Integer): PWideChar; stdcall;
  TCkCsp_NthHashNumBits = function (objHandle: HCkCsp; index: Integer): Integer; stdcall;
  TCkCsp_NthKeyContainerName = function (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkCsp__nthKeyContainerName = function (objHandle: HCkCsp; index: Integer): PWideChar; stdcall;
  TCkCsp_NthKeyExchangeAlgorithm = function (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkCsp__nthKeyExchangeAlgorithm = function (objHandle: HCkCsp; index: Integer): PWideChar; stdcall;
  TCkCsp_NthKeyExchangeNumBits = function (objHandle: HCkCsp; index: Integer): Integer; stdcall;
  TCkCsp_NthSignatureAlgorithm = function (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool; stdcall;
  TCkCsp__nthSignatureAlgorithm = function (objHandle: HCkCsp; index: Integer): PWideChar; stdcall;
  TCkCsp_NthSignatureNumBits = function (objHandle: HCkCsp; index: Integer): Integer; stdcall;
  TCkCsp_SaveLastError = function (objHandle: HCkCsp; path: PWideChar): wordbool; stdcall;
  TCkCsp_SetEncryptAlgorithm = function (objHandle: HCkCsp; name: PWideChar): Integer; stdcall;
  TCkCsp_SetHashAlgorithm = function (objHandle: HCkCsp; name: PWideChar): Integer; stdcall;

var
  _fkt_ptr_arr:   array [0..63] of Pointer;

function _Map( k:Integer; n:String):Pointer;
begin
  Result:=  _fkt_ptr_arr[k];
  if Result = nil then begin
    Chilkat_GetProcedureAddress(Result, n);
    _fkt_ptr_arr[k]:=   Result;
  end;
end;


function CkCsp_Create : HCkCsp;
begin
  result := TCkCsp_Create(_map(0, 'CkCsp_Create'));
end;

procedure CkCsp_Dispose (handle: HCkCsp);
begin
  TCkCsp_Dispose(_map(1, 'CkCsp_Dispose'))
    (handle);
end;


procedure CkCsp_getDebugLogFilePath (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getDebugLogFilePath(_map(2, 'CkCsp_getDebugLogFilePath'))
    (objHandle, outPropVal);
end;

procedure CkCsp_putDebugLogFilePath (objHandle: HCkCsp; newPropVal: PWideChar);
begin
  TCkCsp_putDebugLogFilePath(_map(3, 'CkCsp_putDebugLogFilePath'))
    (objHandle, newPropVal);
end;

function CkCsp__debugLogFilePath (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__debugLogFilePath(_map(4, 'CkCsp__debugLogFilePath'))
    (objHandle);
end;

procedure CkCsp_getEncryptAlgorithm (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getEncryptAlgorithm(_map(5, 'CkCsp_getEncryptAlgorithm'))
    (objHandle, outPropVal);
end;

function CkCsp__encryptAlgorithm (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__encryptAlgorithm(_map(6, 'CkCsp__encryptAlgorithm'))
    (objHandle);
end;

function CkCsp_getEncryptAlgorithmID (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getEncryptAlgorithmID(_map(7, 'CkCsp_getEncryptAlgorithmID'))
    (objHandle);
end;

function CkCsp_getEncryptNumBits (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getEncryptNumBits(_map(8, 'CkCsp_getEncryptNumBits'))
    (objHandle);
end;

procedure CkCsp_getHashAlgorithm (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getHashAlgorithm(_map(9, 'CkCsp_getHashAlgorithm'))
    (objHandle, outPropVal);
end;

function CkCsp__hashAlgorithm (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__hashAlgorithm(_map(10, 'CkCsp__hashAlgorithm'))
    (objHandle);
end;

function CkCsp_getHashAlgorithmID (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getHashAlgorithmID(_map(11, 'CkCsp_getHashAlgorithmID'))
    (objHandle);
end;

function CkCsp_getHashNumBits (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getHashNumBits(_map(12, 'CkCsp_getHashNumBits'))
    (objHandle);
end;

procedure CkCsp_getKeyContainerName (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getKeyContainerName(_map(13, 'CkCsp_getKeyContainerName'))
    (objHandle, outPropVal);
end;

procedure CkCsp_putKeyContainerName (objHandle: HCkCsp; newPropVal: PWideChar);
begin
  TCkCsp_putKeyContainerName(_map(14, 'CkCsp_putKeyContainerName'))
    (objHandle, newPropVal);
end;

function CkCsp__keyContainerName (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__keyContainerName(_map(15, 'CkCsp__keyContainerName'))
    (objHandle);
end;

procedure CkCsp_getLastErrorHtml (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getLastErrorHtml(_map(16, 'CkCsp_getLastErrorHtml'))
    (objHandle, outPropVal);
end;

function CkCsp__lastErrorHtml (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__lastErrorHtml(_map(17, 'CkCsp__lastErrorHtml'))
    (objHandle);
end;

procedure CkCsp_getLastErrorText (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getLastErrorText(_map(18, 'CkCsp_getLastErrorText'))
    (objHandle, outPropVal);
end;

function CkCsp__lastErrorText (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__lastErrorText(_map(19, 'CkCsp__lastErrorText'))
    (objHandle);
end;

procedure CkCsp_getLastErrorXml (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getLastErrorXml(_map(20, 'CkCsp_getLastErrorXml'))
    (objHandle, outPropVal);
end;

function CkCsp__lastErrorXml (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__lastErrorXml(_map(21, 'CkCsp__lastErrorXml'))
    (objHandle);
end;

function CkCsp_getLastMethodSuccess (objHandle: HCkCsp): wordbool;
begin
    result := TCkCsp_getLastMethodSuccess(_map(22, 'CkCsp_getLastMethodSuccess'))
    (objHandle);
end;

procedure CkCsp_putLastMethodSuccess (objHandle: HCkCsp; newPropVal: wordbool);
begin
  TCkCsp_putLastMethodSuccess(_map(23, 'CkCsp_putLastMethodSuccess'))
    (objHandle, newPropVal);
end;

function CkCsp_getMachineKeyset (objHandle: HCkCsp): wordbool;
begin
    result := TCkCsp_getMachineKeyset(_map(24, 'CkCsp_getMachineKeyset'))
    (objHandle);
end;

procedure CkCsp_putMachineKeyset (objHandle: HCkCsp; newPropVal: wordbool);
begin
  TCkCsp_putMachineKeyset(_map(25, 'CkCsp_putMachineKeyset'))
    (objHandle, newPropVal);
end;

function CkCsp_getNumEncryptAlgorithms (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getNumEncryptAlgorithms(_map(26, 'CkCsp_getNumEncryptAlgorithms'))
    (objHandle);
end;

function CkCsp_getNumHashAlgorithms (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getNumHashAlgorithms(_map(27, 'CkCsp_getNumHashAlgorithms'))
    (objHandle);
end;

function CkCsp_getNumKeyContainers (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getNumKeyContainers(_map(28, 'CkCsp_getNumKeyContainers'))
    (objHandle);
end;

function CkCsp_getNumKeyExchangeAlgorithms (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getNumKeyExchangeAlgorithms(_map(29, 'CkCsp_getNumKeyExchangeAlgorithms'))
    (objHandle);
end;

function CkCsp_getNumSignatureAlgorithms (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getNumSignatureAlgorithms(_map(30, 'CkCsp_getNumSignatureAlgorithms'))
    (objHandle);
end;

procedure CkCsp_getProviderName (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getProviderName(_map(31, 'CkCsp_getProviderName'))
    (objHandle, outPropVal);
end;

procedure CkCsp_putProviderName (objHandle: HCkCsp; newPropVal: PWideChar);
begin
  TCkCsp_putProviderName(_map(32, 'CkCsp_putProviderName'))
    (objHandle, newPropVal);
end;

function CkCsp__providerName (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__providerName(_map(33, 'CkCsp__providerName'))
    (objHandle);
end;

function CkCsp_getProviderType (objHandle: HCkCsp): Integer;
begin
    result := TCkCsp_getProviderType(_map(34, 'CkCsp_getProviderType'))
    (objHandle);
end;

procedure CkCsp_getUncommonOptions (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getUncommonOptions(_map(35, 'CkCsp_getUncommonOptions'))
    (objHandle, outPropVal);
end;

procedure CkCsp_putUncommonOptions (objHandle: HCkCsp; newPropVal: PWideChar);
begin
  TCkCsp_putUncommonOptions(_map(36, 'CkCsp_putUncommonOptions'))
    (objHandle, newPropVal);
end;

function CkCsp__uncommonOptions (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__uncommonOptions(_map(37, 'CkCsp__uncommonOptions'))
    (objHandle);
end;

function CkCsp_getVerboseLogging (objHandle: HCkCsp): wordbool;
begin
    result := TCkCsp_getVerboseLogging(_map(38, 'CkCsp_getVerboseLogging'))
    (objHandle);
end;

procedure CkCsp_putVerboseLogging (objHandle: HCkCsp; newPropVal: wordbool);
begin
  TCkCsp_putVerboseLogging(_map(39, 'CkCsp_putVerboseLogging'))
    (objHandle, newPropVal);
end;

procedure CkCsp_getVersion (objHandle: HCkCsp; outPropVal: HCkString);
begin
  TCkCsp_getVersion(_map(40, 'CkCsp_getVersion'))
    (objHandle, outPropVal);
end;

function CkCsp__version (objHandle: HCkCsp): PWideChar;
begin
  result := TCkCsp__version(_map(41, 'CkCsp__version'))
    (objHandle);
end;

function CkCsp_GetKeyContainerNames (objHandle: HCkCsp): HCkStringArray;
begin
  result := TCkCsp_GetKeyContainerNames(_map(42, 'CkCsp_GetKeyContainerNames'))
    (objHandle);
end;

function CkCsp_GetProviders (objHandle: HCkCsp; providerNames: HCkStringTable): wordbool;
begin
  result := TCkCsp_GetProviders(_map(43, 'CkCsp_GetProviders'))
    (objHandle, providerNames);
end;

function CkCsp_HasEncryptAlgorithm (objHandle: HCkCsp; name: PWideChar; numBits: Integer): wordbool;
begin
  result := TCkCsp_HasEncryptAlgorithm(_map(44, 'CkCsp_HasEncryptAlgorithm'))
    (objHandle, name, numBits);
end;

function CkCsp_HasHashAlgorithm (objHandle: HCkCsp; name: PWideChar; numBits: Integer): wordbool;
begin
  result := TCkCsp_HasHashAlgorithm(_map(45, 'CkCsp_HasHashAlgorithm'))
    (objHandle, name, numBits);
end;

function CkCsp_Initialize (objHandle: HCkCsp): wordbool;
begin
  result := TCkCsp_Initialize(_map(46, 'CkCsp_Initialize'))
    (objHandle);
end;

function CkCsp_NthEncryptionAlgorithm (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkCsp_NthEncryptionAlgorithm(_map(47, 'CkCsp_NthEncryptionAlgorithm'))
    (objHandle, index, outStr);
end;

function CkCsp__nthEncryptionAlgorithm (objHandle: HCkCsp; index: Integer): PWideChar;
begin
  result := TCkCsp__nthEncryptionAlgorithm(_map(48, 'CkCsp__nthEncryptionAlgorithm'))
    (objHandle, index);
end;

function CkCsp_NthEncryptionNumBits (objHandle: HCkCsp; index: Integer): Integer;
begin
  result := TCkCsp_NthEncryptionNumBits(_map(49, 'CkCsp_NthEncryptionNumBits'))
    (objHandle, index);
end;

function CkCsp_NthHashAlgorithmName (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkCsp_NthHashAlgorithmName(_map(50, 'CkCsp_NthHashAlgorithmName'))
    (objHandle, index, outStr);
end;

function CkCsp__nthHashAlgorithmName (objHandle: HCkCsp; index: Integer): PWideChar;
begin
  result := TCkCsp__nthHashAlgorithmName(_map(51, 'CkCsp__nthHashAlgorithmName'))
    (objHandle, index);
end;

function CkCsp_NthHashNumBits (objHandle: HCkCsp; index: Integer): Integer;
begin
  result := TCkCsp_NthHashNumBits(_map(52, 'CkCsp_NthHashNumBits'))
    (objHandle, index);
end;

function CkCsp_NthKeyContainerName (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkCsp_NthKeyContainerName(_map(53, 'CkCsp_NthKeyContainerName'))
    (objHandle, index, outStr);
end;

function CkCsp__nthKeyContainerName (objHandle: HCkCsp; index: Integer): PWideChar;
begin
  result := TCkCsp__nthKeyContainerName(_map(54, 'CkCsp__nthKeyContainerName'))
    (objHandle, index);
end;

function CkCsp_NthKeyExchangeAlgorithm (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkCsp_NthKeyExchangeAlgorithm(_map(55, 'CkCsp_NthKeyExchangeAlgorithm'))
    (objHandle, index, outStr);
end;

function CkCsp__nthKeyExchangeAlgorithm (objHandle: HCkCsp; index: Integer): PWideChar;
begin
  result := TCkCsp__nthKeyExchangeAlgorithm(_map(56, 'CkCsp__nthKeyExchangeAlgorithm'))
    (objHandle, index);
end;

function CkCsp_NthKeyExchangeNumBits (objHandle: HCkCsp; index: Integer): Integer;
begin
  result := TCkCsp_NthKeyExchangeNumBits(_map(57, 'CkCsp_NthKeyExchangeNumBits'))
    (objHandle, index);
end;

function CkCsp_NthSignatureAlgorithm (objHandle: HCkCsp; index: Integer; outStr: HCkString): wordbool;
begin
  result := TCkCsp_NthSignatureAlgorithm(_map(58, 'CkCsp_NthSignatureAlgorithm'))
    (objHandle, index, outStr);
end;

function CkCsp__nthSignatureAlgorithm (objHandle: HCkCsp; index: Integer): PWideChar;
begin
  result := TCkCsp__nthSignatureAlgorithm(_map(59, 'CkCsp__nthSignatureAlgorithm'))
    (objHandle, index);
end;

function CkCsp_NthSignatureNumBits (objHandle: HCkCsp; index: Integer): Integer;
begin
  result := TCkCsp_NthSignatureNumBits(_map(60, 'CkCsp_NthSignatureNumBits'))
    (objHandle, index);
end;

function CkCsp_SaveLastError (objHandle: HCkCsp; path: PWideChar): wordbool;
begin
  result := TCkCsp_SaveLastError(_map(61, 'CkCsp_SaveLastError'))
    (objHandle, path);
end;

function CkCsp_SetEncryptAlgorithm (objHandle: HCkCsp; name: PWideChar): Integer;
begin
  result := TCkCsp_SetEncryptAlgorithm(_map(62, 'CkCsp_SetEncryptAlgorithm'))
    (objHandle, name);
end;

function CkCsp_SetHashAlgorithm (objHandle: HCkCsp; name: PWideChar): Integer;
begin
  result := TCkCsp_SetHashAlgorithm(_map(63, 'CkCsp_SetHashAlgorithm'))
    (objHandle, name);
end;

end.
